function fig = dctlab()
%Version: 2.00, Date: 2005/04/01, author: Nikola Sprljan
%GUI for DCTlab

set(0,'Units','pixels');
scrsz = get(0,'ScreenSize');
scrsz(2) = round(scrsz(4)*0.1);
scr3new = round(scrsz(4)*1.25);
scrsz(4) = round(scrsz(4)*0.85);
scrsz(1) = 1 + round((scrsz(3) - scr3new)/2);
scrsz(3) = scr3new;
HVratio = scrsz(3) / scrsz(4);

clmap = gray(256);
clmap = [clmap;clmap];
climaxes = [0 511];
dfltbck = clmap(193,:);
dfltaxbck = clmap(235,:);
figureclr = clmap(177,:);

tableticks = [0.1250    0.2500    0.3750    0.5000    0.6250    0.7500    0.8750];

h0 = figure('Units','pixels','Color',figureclr,'Colormap',clmap,'MenuBar','none','MinColormap',512,...
	'Name','DCTlab','NumberTitle','off','HandleVisibility','callback','Interruptible','off',...
    'Position',scrsz,'ShareColors','off', ...
    'Tag','Fig1');%'Resize','off',...
set(0,'Units','normalized');

h1 = uimenu('Parent',h0,'Label','File','Tag','uimenu1');
 h2 = uimenu('Parent',h1,'Callback','dctact getfile','Label','Open','Tag','Fileuimenu1');
 h2 = uimenu('Parent',h1,'Callback','dctact exit','Label','Exit','Tag','Fileuimenu2');
h1 = uimenu('Parent',h0,'Callback','dctact help','Label','Help','Tag','uimenu3');

%%%%ORIGINAL IMAGE%%%%
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck, ...
    'Position',[0.005 0.9096 0.170 0.0840], ...
	'Style','frame','Tag','Frame1');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck, ...
	'FontSize',0.4,'FontWeight','demi', ...
	'Position',[0.01 0.943 0.160 0.04], ...
	'String','Original Image','Style','text','Tag','StaticText1');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,...
    'FontSize',0.75, ...
    'Position',[0.01 0.915 0.160 0.025],...
    'Style','text','Tag','StaticText2');
h1 = axes('Parent',h0,'Box','on','Color',dfltaxbck,'CLim',climaxes,'CLimMode','manual','NextPlot','add', ...
	'Position',[0.180 0.5255 0.3175 0.4671], ...
	'Tag','Axes1','TickDirMode','manual', ...
	'XColor',[0 0 0],'XLim',[1 10],'XLimMode','manual','XTickLabelMode','manual','XTickMode','manual', ...
	'YColor',[0 0 0],'YDir','reverse','YLim',[1 10],'YLimMode','manual','YTickLabelMode','manual','YTickMode','manual');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltaxbck, ...
	'FontSize',0.75,'HorizontalAlignment','left', ...       
	'Position',[0.005 0.8772 0.170 0.025], ...
	'String',' (xy1,xy2)=','Style','text','Tag','StaticText7');
h1 = axes('Parent',h0,'Box','on','Color',dfltaxbck,'GridLineStyle','-','LineWidth',2,'NextPlot','add', ...
	'Position',[0.005 0.6197 0.170 0.2501], ...
	'Tag','Axes3','TickLength',[0 0], ...
	'XColor',[0 0 0],'XGrid','on','XTick',tableticks,'XTickLabelMode','manual','XTickMode','manual', ...
	'YColor',[0 0 0],'YGrid','on','YTick',tableticks,'YTickLabelMode','manual','YTickMode','manual');

%%%%DCT - CONTROLS%%%%
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'Position',[0.005 0.2268 0.170 0.3855], ...
	'Style','frame','Tag','Frame2','UserData',2);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck, ...
	'FontSize',0.4,'FontWeight','demi', ...
	'Position',[0.01 0.5627 0.160 0.04], ...
	'String','DCT','Style','text','Tag','StaticText3','UserData',2);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
    'Position',[0.01 0.47 0.160 0.025], ...
	'String','size of block:','Style','text','Tag','StaticText4','UserData',2);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','Callback','dctact set_rec_button','Enable','off', ...
	'FontSize',0.75,...
	'Position',[0.015 0.44 0.08875 0.025], ...
	'String',['4x4    ';'8x8    ';'16x16  ';'32x32  ';'64x64  ';'128x128';'256x256'], ...
	'Style','popupmenu','Tag','PopupMenu1','UserData',2,'Value',7);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','Callback','dctact dctlevel','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75, ...
	'Position',[0.015 0.52 0.1475 0.025], ...
	'String','DC level shift','Style','checkbox','Tag','Checkbox2','UserData',2);
h1 = uicontrol('Parent',h0,'Units','normalized', 'FontUnits','normalized','Callback','dctact dajdct','Enable','off', ...
	'FontSize',0.35,'FontWeight','bold', ...
	'Position',[0.11 0.43 0.06 0.04], ...
	'String','Apply >>','Tag','Pushbutton1','UserData',2);
h1 = axes('Parent',h0,'Box','on','Color',[0 0 0],'CLim',climaxes,'CLimMode','manual','NextPlot','replace',...
    'Position',[0.18 0.2268 0.198 0.2913], ...
	'Tag','Axes2', ...
	'XColor',[0 0 0],'XLimMode','manual','XTickMode','manual',...
    'YColor',[0 0 0],'YDir','reverse','YLimMode','manual','YTickMode','manual');

%%%%DCT - GAMMA SLIDER%%%%
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck,'ListboxTop',0, ...
	'Position',[0.01 0.2342 0.16 0.15], ...
	'Style','frame','Tag','Frame3');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Callback','dctact linlog','Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.015 0.34 0.14 0.025], ...
	'String','gamma: 0','Style','text','Tag','StaticText5','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.013 0.31 0.01 0.025], ...
	'String','-1','Style','text', 'Tag','StaticText6','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.16 0.31 0.008 0.025],'String','1', ...
	'Style','text','Tag','StaticText6_1','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck,'Callback','dctact slidegamma','Enable','off','Interruptible','off', ...
	'Min',-1,'SliderStep',[0.0005 0.05], ...
	'Position',[0.026 0.315 0.13 0.025], ... 
	'Style','slider','Tag','Slider1','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Callback','dctact invertkoef','Enable','off','Interruptible','off',  ...
	'FontSize',0.75, ...
	'Position',[0.026 0.281 0.14 0.025], ...
	'String','invert colormap','Style','checkbox','Tag','Checkbox1','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Callback','dctact linlog','Enable','off', ...
	'FontSize',0.75, ...
	'Position',[0.07625 0.245 0.06125 0.025], ...
	'String','log','Style','radiobutton','Tag','Radiobutton1','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Callback','dctact linlog','Enable','off', ...
	'FontSize',0.75, ...
	'Position',[0.02375 0.245 0.05125 0.025], ...
	'String','lin','Style','radiobutton','Tag','Radiobutton2','UserData',3,'Value',1);

%%%%DCT DISPLAY AXES%%%%
h1 = axes('Parent',h0,'Box','on','Color',dfltaxbck,'GridLineStyle','-','LineWidth',2, ...
	'Position',[0.005 0.0074 0.373 0.212], ...
	'Tag','dctaxes','TickLength',[0 0], ...
	'XColor',[0 0 0],'XGrid','on','XTick',tableticks,'XTickLabelMode','manual','XTickMode','manual', ...
	'YColor',[0 0 0],'YGrid','on','YTick',tableticks,'YTickLabelMode','manual','YTickMode','manual');

%%%%THRESHOLDING%%%%
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'Position',[0.384 0.3181 0.2062 0.2], ...
	'Style','frame','Tag','Frame4','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck, ...
	'FontSize',0.4,'FontWeight','demi', ...
	'Position',[0.389 0.4723 0.1962 0.04], ...
	'String','Threshold','Style','text','Tag','StaticText8');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.394 0.445 0.19 0.025], ...
	'String','|coeff| in range []','Style','text','Tag','StaticText9','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.394 0.41 0.15 0.025], ...
	'String','set threshold:','Style','text','Tag','StaticText10','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',[1 1 1],'Callback','dctact set_treshold','Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.48 0.41 0.085 0.025], ...
	'Style','edit','Tag','EditText1','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left','ListboxTop',0, ...
	'Position',[0.394 0.375 0.16375 0.025], ...
	'String','% coeff==0','Style','text','Tag','StaticText11','UserData',3);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','Callback','dctact reconstruction','Enable','off', ...
    'FontSize',0.35,'FontWeight','bold', ...
	'Position',[0.4221 0.327 0.130 0.04], ...
	'String','Reconstruction >>','Tag','Pushbutton2','UserData',3);

%%%%QUANTISATION STEPS AND ZIG-ZAG SCANNING ORDER TABLE%%%%
h1 = axes('Parent',h0,'Box','on','Color',dfltaxbck,'GridLineStyle','-','LineWidth',2,'NextPlot','add', ...
	'Position',[0.384 0.0074 0.2062 0.3033], ...
	'Tag','quant_axes','TickLength',[0 0], ...
	'XColor',[0.356862745098039 0.356862745098039 0.356862745098039],'XGrid','on','XTick',tableticks,'XTickLabelMode','manual','XTickMode','manual', ...
	'YColor',[0.356862745098039 0.356862745098039 0.356862745098039],'YGrid','on','YTick',tableticks,'YTickLabelMode','manual','YTickMode','manual');

%%%%QUANTISATION%%%%
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck, ...
	'Position',[0.5952 0.2268 0.1775 0.2913],'Style','frame','Tag','quant_Frame');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,...
    'FontSize',0.4,'FontWeight','demi', ...
	'Position',[0.6002 0.4723 0.1675 0.04], ...
	'String','Quantisation','Style','text','Tag','quant');
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck,'Callback','dctact set_rec_button', ...
	'Position',[0.61 0.485 0.0175 0.03],...
    'Style','checkbox','Tag','quant_check','UserData',2,'Value',1);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','Callback','dctact reconstruction','Enable','off', ...
	'FontSize',0.35,'FontWeight','bold',...
	'Position',[0.6189 0.24 0.130 0.04],...
    'String','Reconstruction >>','Tag','quant_button','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.61 0.45 0.16 0.025], ...
	'String','Quantisation table:','Style','text','Tag','quant_static1','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.61 0.39 0.16 0.025], ...
	'String','Zig-zag scan order:','Style','text','Tag','quant_static2','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontAngle','italic','FontSize',0.75,'FontWeight','demi', ...
	'Position',[0.6 0.42 0.1575 0.025], ...
	'Style','text','Tag','quant_text1','UserData',3.5,'Value',1);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontAngle','italic','FontSize',0.75,'FontWeight','demi', ...
	'Position',[0.6 0.36 0.1575 0.025], ...
	'Style','text','Tag','quant_text2','UserData',3.5,'Value',1);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.6 0.33 0.17 0.025], ...
	'String','Multiplication factor: ','Style','text','Tag','quant_text3','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.596 0.3 0.1 0.025], ...
	'String','1/256','Style','text','Tag','quant_static3','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck,'Callback','dctact slidequant','Enable','off','Interruptible','off', ...
	'Max',8,'Min',-8,'SliderStep',[0.003125 0.0625],...
	'Position',[0.625 0.3 0.12 0.025], ...
    'Style','slider','Tag','quant_slider','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.746 0.3 0.025 0.025], ...
	'String','256','Style','text','Tag','quant_static3_1','UserData',3.5);

%%%%QUANTISED DCT COEFFICIENTS TABLE%%%%
h1 = axes('Parent',h0,'Box','on','Color',dfltaxbck,'GridLineStyle','-','LineWidth',2,'NextPlot','add', ...
	'Position',[0.5952 0.0074 0.1775 0.212], ...
	'Tag','quantised_axes','TickLength',[0 0], ...
	'XColor',[0 0 0],'XGrid','on','XTick',tableticks,'XTickLabelMode','manual','XTickMode','manual',...
    'YColor',[0 0 0],'YGrid','on','YTick',tableticks,'YTickLabelMode','manual','YTickMode','manual');
    
%%%%RECONSTRUCTED/ERROR IMAGE%%%%
h1 = axes('Parent',h0,'FontUnits','normalized','Box','on','Color',dfltaxbck, ...
	'FontSize',0.04,'NextPlot','add',...
    'Position',[0.5025 0.5255 0.3175 0.4671], ...
	'Tag','error_axes','TickDirMode','manual',...
    'XColor',[0 0 0],'XLim',[1 10],'XLimMode','manual','XTickLabelMode','manual','XTickMode','manual', ...
	'YColor',[0 0 0],'YDir','reverse','YLim',[1 10],'YLimMode','manual','YTickLabelMode','manual','YTickMode','manual');
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck, ...
	'Position',[0.8250 0.783 0.170 0.2096], ...
	'Style','frame','Tag','Frame5');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck, ...
	'FontSize',0.4,'FontWeight','demi', ...
	'Position',[0.83 0.943 0.160 0.04], ...
	'String','Reconstructed Image','Style','text','Tag','reconstructed');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.83 0.925 0.15 0.025], ...
	'String','MSE= ','Style','text','Tag','QM_1','UserData',4);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.83 0.9 0.15 0.025], ...
	'String','PSNR= ','Style','text','Tag','QM_2','UserData',4);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.83 0.875 0.15 0.025], ...
	'String','AD= ','Style','text','Tag','QM_3','UserData',4);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.83 0.85 0.15 0.025], ...
	'String','MD= ','Style','text','Tag','QM_4','UserData',4);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.83 0.825 0.15 0.025], ...
	'String','LMSE= ','Style','text','Tag','QM_5','UserData',4);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.83 0.8 0.15 0.025], ...
	'String','NAE= ','Style','text','Tag','QM_6','UserData',4);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.83 0.788 0.15 0.015], ...
	'String','*details in iq_measures.m','Style','text','Tag','QM_help','UserData',4);

%%%%RECONSTRUCTED/ERROR IMAGE - DISPLAY AXES%%%%
h1 = axes('Parent',h0,'Box','on','Color',dfltaxbck,'GridLineStyle','-','LineWidth',2,'NextPlot','add', ...
	'Position',[0.8250 0.5255 0.170 0.2501], ...
	'Tag','idct_block_axes','TickLength',[0 0], ...
	'XColor',[0 0 0],'XGrid','on','XTick',tableticks,'XTickLabelMode','manual','XTickMode','manual', ...
	'YColor',[0 0 0],'YGrid','on','YTick',tableticks,'YTickLabelMode','manual','YTickMode','manual');

%%%%RECONSTRUCTED IMAGE - GAMMA SLIDER%%%%
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck,...
    'Position',[0.83 0.79 0.16 0.12], ...
	'Style','frame','Tag','Frame6','UserData',4,'Visible','off');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Callback','dctact linlog','Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.835 0.865 0.15 0.025], ...
	'String','gamma: 0','Style','text','Tag','err_text1','UserData',4,'Visible','off');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.833 0.835 0.01 0.025], ...
	'String','-1','Style','text','Tag','err_text2','UserData',4,'Visible','off');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.98 0.835 0.008 0.025], ...
	'String','1','Style','text','Tag','err_text2_1','UserData',4,'Visible','off');
h1 = uicontrol('Parent',h0,'Units','normalized','BackgroundColor',dfltbck,'Callback','dctact slidegamma','Enable','off','Interruptible','off', ...
    'Min',-1,'SliderStep',[0.0005 0.05], ...
	'Position',[0.846 0.84 0.13 0.025], ...
	'Style','slider','Tag','err_slider','UserData',4,'Visible','off');
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Callback','dctact invertkoef','Enable','off','Interruptible','off', ...
	'FontSize',0.75, ...
	'Position',[0.846 0.806 0.14 0.025], ...
	'String','invert colormap','Style','checkbox','Tag','err_checkbox','UserData',4,'Visible','off');

%%%%CODE BLOCK%%%%
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck, ...
	'FontSize',0.038, ...
	'Position',[0.7777 0.0074 0.2173 0.5107],'Style','frame','Tag','code_Frame');
h1 = uicontrol('Parent',h0, 'Units','normalized', 'FontUnits','normalized', 'Callback','dctact coding','Enable','off', ...
	'FontSize',0.35, 'FontWeight','bold',...
	'Position',[0.8188 0.468 0.135 0.04], ...
	'String','Start coding >>', 'Tag','code_start','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left','ListboxTop',0, ...
	'Position',[0.7925 0.43 0.16 0.025], ...
	'String','Huffman table:','Style','text','Tag','code_static1','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off','FontAngle','italic', ...
	'FontSize',0.75,'FontWeight','demi','ListboxTop',0, ...
	'Position',[0.7825 0.40 0.1575 0.025], ...
	'Style','text','Tag','code_text0','UserData',3.5,'Value',1);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left',...
	'Position',[0.785 0.37 0.16375 0.025], ...
	'String','total DC bits=','Style','text','Tag','code_text1','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.785 0.34 0.16375 0.025],...
    'String','total AC bits=','Style','text','Tag','code_text2','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',dfltbck,'Enable','off', ...
	'FontSize',0.75,'HorizontalAlignment','left', ...
	'Position',[0.785 0.31 0.18 0.025], ...
	'String','bit-rate=','Style','text','Tag','code_text3','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','Callback','dctact code_block','Enable','off', ...
    'FontSize',0.35,'FontWeight','bold', ...
    'Position',[0.8213 0.265 0.130 0.04], ...
	'String','Encode slct. block >>','Tag','code_block','UserData',3.5);
h1 = uicontrol('Parent',h0,'Units','normalized','FontUnits','normalized','BackgroundColor',[1 1 1],'Enable','off', 'FontName','Courier',...
    'FontSize',0.09,'HorizontalAlignment','left','Max',2, ...
	'Position',[0.7827 0.0148 0.2073 0.2428], ...
	'Style','listbox','Tag','code_list','UserData',3.5,'Value',[]);
h1 = uicontrol('Parent',h0,'CreateFcn','dctact load_defaults','Style','text','Visible','off'); %dummy object
if nargout > 0, fig = h0; end
